#   File:       iso9660.make
#   Target:     iso9660
#   Sources:    iso9660.r
#               :Srcs:BuildISO.c
#               :Srcs:DialogUtils.c
#               :Srcs:ErrorMsg.c
#               :Srcs:i_o.c
#               :Srcs:main.c
#               :Srcs:mydialog.c
#               :Srcs:support.c
#               :Srcs:TextDlog.c
#   Created:    Thursday, September 28, 1995 09:32:45 AM


MAKEFILE     = iso9660.make
MondoBuild = {MAKEFILE}  # Make blank to avoid rebuilds when makefile is modified
Includes     =
SymPPC      = 
ObjDirPPC   = :Objs:
Sym68K      = 
ObjDir68K   = :Objs:

PPCCOptions  = {Includes} {SymPPC} 

COptions     = {Includes} {Sym68K} 

ObjectsPPC  = 
		"{ObjDirPPC}BuildISO.c.x" 
		"{ObjDirPPC}DialogUtils.c.x" 
		"{ObjDirPPC}ErrorMsg.c.x" 
		"{ObjDirPPC}i_o.c.x" 
		"{ObjDirPPC}main.c.x" 
		"{ObjDirPPC}mydialog.c.x" 
		"{ObjDirPPC}support.c.x" 
		"{ObjDirPPC}TextDlog.c.x"

Objects68K  = 
		"{ObjDir68K}BuildISO.c.o" 
		"{ObjDir68K}DialogUtils.c.o" 
		"{ObjDir68K}ErrorMsg.c.o" 
		"{ObjDir68K}i_o.c.o" 
		"{ObjDir68K}main.c.o" 
		"{ObjDir68K}mydialog.c.o" 
		"{ObjDir68K}support.c.o" 
		"{ObjDir68K}TextDlog.c.o"


iso9660  {MondoBuild} {ObjectsPPC}
	PPCLink 
		-o {Targ} {SymPPC} 
		{ObjectsPPC} 
		-t 'APPL' 
		-c '????' 
		"{SharedLibraries}InterfaceLib" 
		"{SharedLibraries}StdCLib" 
		"{SharedLibraries}MathLib" 
		"{PPCLibraries}StdCRuntime.o" 
		"{PPCLibraries}PPCCRuntime.o" 
		"{PPCLibraries}PPCToolLibs.o"


iso9660  {MondoBuild} {Objects68K}
	Link 
		-o {Targ} -d {Sym68K} 
		{Objects68K} 
		-t 'APPL' 
		-c '????' 
		"{Libraries}MathLib.o" 
		#"{CLibraries}Complex.o" 
		"{CLibraries}StdCLib.o" 
		"{Libraries}MacRuntime.o" 
		"{Libraries}IntEnv.o" 
		"{Libraries}ToolLibs.o" 
		"{Libraries}Interface.o"


iso9660  {MondoBuild} iso9660.r
	Rez iso9660.r -o {Targ} {Includes} -append


"{ObjDirPPC}BuildISO.c.x"  {MondoBuild} :Srcs:BuildISO.c
	{PPCC} :Srcs:BuildISO.c -o {Targ} {PPCCOptions}

"{ObjDirPPC}DialogUtils.c.x"  {MondoBuild} :Srcs:DialogUtils.c
	{PPCC} :Srcs:DialogUtils.c -o {Targ} {PPCCOptions}

"{ObjDirPPC}ErrorMsg.c.x"  {MondoBuild} :Srcs:ErrorMsg.c
	{PPCC} :Srcs:ErrorMsg.c -o {Targ} {PPCCOptions}

"{ObjDirPPC}i_o.c.x"  {MondoBuild} :Srcs:i_o.c
	{PPCC} :Srcs:i_o.c -o {Targ} {PPCCOptions}

"{ObjDirPPC}main.c.x"  {MondoBuild} :Srcs:main.c
	{PPCC} :Srcs:main.c -o {Targ} {PPCCOptions}

"{ObjDirPPC}mydialog.c.x"  {MondoBuild} :Srcs:mydialog.c
	{PPCC} :Srcs:mydialog.c -o {Targ} {PPCCOptions}

"{ObjDirPPC}support.c.x"  {MondoBuild} :Srcs:support.c
	{PPCC} :Srcs:support.c -o {Targ} {PPCCOptions}

"{ObjDirPPC}TextDlog.c.x"  {MondoBuild} :Srcs:TextDlog.c
	{PPCC} :Srcs:TextDlog.c -o {Targ} {PPCCOptions}


"{ObjDir68K}BuildISO.c.o"  {MondoBuild} :Srcs:BuildISO.c
	{C} :Srcs:BuildISO.c -o {Targ} {COptions}

"{ObjDir68K}DialogUtils.c.o"  {MondoBuild} :Srcs:DialogUtils.c
	{C} :Srcs:DialogUtils.c -o {Targ} {COptions}

"{ObjDir68K}ErrorMsg.c.o"  {MondoBuild} :Srcs:ErrorMsg.c
	{C} :Srcs:ErrorMsg.c -o {Targ} {COptions}

"{ObjDir68K}i_o.c.o"  {MondoBuild} :Srcs:i_o.c
	{C} :Srcs:i_o.c -o {Targ} {COptions}

"{ObjDir68K}main.c.o"  {MondoBuild} :Srcs:main.c
	{C} :Srcs:main.c -o {Targ} {COptions}

"{ObjDir68K}mydialog.c.o"  {MondoBuild} :Srcs:mydialog.c
	{C} :Srcs:mydialog.c -o {Targ} {COptions}

"{ObjDir68K}support.c.o"  {MondoBuild} :Srcs:support.c
	{C} :Srcs:support.c -o {Targ} {COptions}

"{ObjDir68K}TextDlog.c.o"  {MondoBuild} :Srcs:TextDlog.c
	{C} :Srcs:TextDlog.c -o {Targ} {COptions}

